# -*- coding: iso-8859-1 -*-

import CairoChart, time, sys

## Example 1 - monthly stat with independent y0 and y1-axis

data = [['10.2005', 478, 3], ['11.2005', 438, 7], ['12.2005', 643, 5], ['01.2006', 755, 4],
        ['02.2006', 484, 10], ['03.2006', 528, 3], ['04.2006', 453, 3], ['05.2006', 117, 1]]

img = CairoChart.Chart(width=330, height=250, out='/tmp/cairochart01.png', 
                       colors={'bg':'#FFFFFF', 'fg' : '#000066', 'grid': '#AAAAAA'},
                       font={'name' : 'Trebuchet MS', 'size' : 10,
                             'bold' : False, 'italic' : False})
img.set_title('Monthly order stats', copyright = '(c) bettercom 2006')
img.set_legend([('Delivered orders', '#00AA00'), ('\nRefrained orders', '#AA4444')])
img.set_data(data, y2=[2], colwidth=40, align='r')
img.draw_grid()
img.draw_data(dots=True)
img.output()

## Example 2 - monthly stat with stacked values and additional transparent text

data = [['10.2005', 481, 120, 455, 88], ['11.2005', 445, 93, 477, 188], ['12.2005', 548, 268, 825, 199],
        ['01.2006', 559, 301, 506, 277], ['02.2006', 494, 253, 665, 217], ['03.2006', 531, 115, 650, 103],
        ['04.2006', 455, 91, 425, 130], ['05.2006', 417, 140, 554, 180]]

img = CairoChart.Chart(width=330, height=250, out='/tmp/cairochart02.png', 
                       colors={'bg':'#FFFFFF', 'fg' : '#000066', 'grid': '#AAAAAA'},
                       font={'name' : 'TSCu_Comic', 'size' : 10,
                             'bold' : False, 'italic' : False})
img.set_title('Monthly phone stats', copyright = '(c) 2006')
img.set_legend([('Incoming calls local', '#AA7700'),
                ('Incoming calls international', '#FFCC33'),
                ('\nOutgoing calls local', '#0077A0'),
                ('Outgoing calls international', '#4EC9CA')],
               font={'size':9})
img.set_data(data, stack=[(2,1),(4,3)], colwidth=20, align='r')
img.draw_grid()
img.draw_data()
img.text('Confidential', 60, img.area[3], font={'size':50}, color={'_n':'#FF0000', 'alpha':0.3}, rotate=-35)
img.output()

## Example 3 - suppress 0 values ##

v = dict([('14.05.2005', 242), ('21.05.2005', 234), ('27.05.2005', 243), ('01.06.2005', 259),
          ('08.06.2005', 62), ('14.06.2005', 48), ('20.06.2005', 68), ('27.06.2005', 165),
          ('04.07.2005', 137), ('10.07.2005', 150), ('16.07.2005', 214), ('23.07.2005', 157),
          ('30.07.2005', 161), ('05.08.2005', 166), ('12.08.2005', 140), ('18.08.2005', 140),
          ('25.08.2005', 158), ('31.08.2005', 152), ('07.09.2005', 304), ('13.09.2005', 237),
          ('20.09.2005', 241), ('26.09.2005', 231), ('02.10.2005', 245), ('08.10.2005', 255),
          ('15.10.2005', 253), ('21.10.2005', 253), ('29.10.2005', 235), ('04.11.2005', 257),
          ('11.11.2005', 290), ('17.11.2005', 219), ('24.11.2005', 289), ('01.12.2005', 301),
          ('08.12.2005', 235), ('15.12.2005', 217), ('22.12.2005', 213), ('28.12.2005', 214),
          ('04.01.2006', 244), ('10.01.2006', 225), ('17.01.2006', 220), ('24.01.2006', 196),
          ('31.01.2006', 218), ('10.02.2006', 219), ('21.02.2006', 164), ('03.03.2006', 223),
          ('14.03.2006', 269), ('28.03.2006', 286), ('11.04.2006', 161), ('22.04.2006', 179),
          ('29.04.2006', 190), ('07.05.2006', 434), ('15.05.2006', 251)])

days = 360
t = list(time.localtime())
t[1] -= 14
t[2] = 1
t[4] -= 10
t2 = time.localtime(time.mktime(t))

t = list(time.localtime())
t[1] += 1
t[2] = 1
t[3:] = 0,0,0,0,0,-1
t_end = time.localtime(time.mktime(t))

data = []

while t2 < t_end:
    _x = time.strftime('%d.%m.%Y', t2)
    data.append((_x, v.get(_x, 0) * 2))
    t2 = time.localtime(time.mktime(t2) + 86400)

img = CairoChart.Chart(width=330, height=250, type='line', out='/tmp/cairochart03.png',
                       colors={'bg':'#fbfab3', 'fg' : '#000066', 'grid': '#88FF88'})
img.set_title('Closed files per day', copyright = '(c) bettercom.de 2006', font={'size':15, 'italic':True})
img.set_legend([('Number of files closed', '#CC00CC')
                ])
img.set_data(data, colwidth=1.5, margin=0, align='r')
img.draw_grid(suppress_0s=True)
img.draw_data(dots=True)
img.output()
